From 0b329751aae57eaf04286949bcba093504b90651 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 04 2015 19:46:20 +0000
Subject: [PATCH 64/1001] Personal hub creation done.


---

diff --git a/hubs/app.py b/hubs/app.py
index 0b98b60..2fee16a 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -29,7 +29,10 @@ session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 
 @app.route('/')
 def index():
-    return flask.redirect('/designteam')  # TODO - remove this later
+    if not flask.g.auth.logged_in:
+        return flask.redirect(flask.url_for('login_fedora'))
+
+    return flask.redirect(flask.url_for('hub', name=flask.g.auth.nickname))
 
 
 @app.route('/<name>')
@@ -162,6 +165,11 @@ def after_openid_login(resp):
     flask.app.session['fullname'] = resp.fullname
     flask.app.session['nickname'] = resp.nickname or resp.fullname
     flask.app.session['email'] = resp.email
+
+    openid = openid_url.strip('/').split('/')[-1]
+    hubs.models.User.get_or_create(
+        session, openid=openid, fullname=resp.fullname)
+
     next_url = flask.request.args.get('next', default)
     return flask.redirect(next_url)
 
@@ -176,13 +184,6 @@ def login_required(function):
             return flask.redirect(flask.url_for(
                 'login_fedora', next=flask.request.url))
 
-        # TODO - Ensure that the logged in user exists before we proceed.
-        hubs.models.User.get_or_create(
-            session,
-            openid=flask.g.auth.openid,
-            openid_url=flask.g.auth.openid_url,
-        )
-
         return function(*args, **kwargs)
     return decorated_function
 
@@ -196,7 +197,7 @@ def check_auth():
         id=None,
     )
     if 'openid' in flask.session:
-        openid = flask.session.get('openid').split('/')[-1]
+        openid = flask.session.get('openid').strip('/').split('/')[-1]
         flask.g.auth.logged_in = True
         flask.g.auth.method = u'openid'
         flask.g.auth.openid = openid
diff --git a/hubs/models.py b/hubs/models.py
index 49eb665..7653c2e 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -94,6 +94,26 @@ class Hub(BASE):
     members = ['ralph', 'sadin', 'sayan'] + owners
     subscribers = []
 
+    @classmethod
+    def by_name(cls, session, name):
+        return session.query(cls).filter_by(name=name).first()
+
+    @classmethod
+    def create_user_hub(cls, session, username, fullname):
+        hub = cls(name=username, summary=fullname)
+        session.add(hub)
+
+        widget = Widget(plugin='sticky', index=0, left=True,
+                        _config=json.dumps({
+                            'text': 'TODO -- put a fancy graph here..',
+                        }))
+        hub.widgets.append(widget)
+        widget = Widget(plugin='sticky', index=0,
+                        _config=json.dumps({
+                            'text': 'TODO -- your feed goes here.',
+                        }))
+        hub.widgets.append(widget)
+
     @property
     def right_width(self):
         return 12 - self.left_width
@@ -158,16 +178,19 @@ class Widget(BASE):
 class User(BASE):
     __tablename__ = 'users'
     openid = sa.Column(sa.Text, primary_key=True)
-    openid_url = sa.Column(sa.Text, unique=True)
+    fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
 
     def __json__(self, reify=False):
         return {
             'openid': self.openid,
-            'openid_url': self.openid_url,
             'created_on': self.created_on,
         }
 
+    @property
+    def username(self):
+        return self.openid.split('.')[0]
+
     @classmethod
     def by_openid(cls, session, openid):
         return session.query(cls).filter_by(openid=openid).first()
@@ -177,3 +200,17 @@ class User(BASE):
     @classmethod
     def all(cls, session):
         return session.query(cls).all()
+
+    @classmethod
+    def get_or_create(cls, session, openid, fullname):
+        if not openid:
+            raise ValueError("Must provide openid, not %r" % openid)
+
+        self = cls.by_openid(session, openid)
+        if not self:
+            self = cls(openid=openid, fullname=fullname)
+            session.add(self)
+            if not Hub.by_name(session, self.username):
+                Hub.create_user_hub(session, self.username, self.fullname)
+            session.commit()
+        return self

